Subject: Re: [PATCH, untested] Support for PPPOE on SMP

From: Ben Greear <[email-masked]>
Date: Wed, 25 Jun 2003 15:53:10 -0700

Paul Mackerras wrote:
> Jamal Hadi writes:
> 
> 
>>a protocol or implementation which wishes to do state maintanance
>>properly oughta be able to do the synchronization on its own.
>>Separation between policy and mechanism has been the strength of unix.
>>A clean separation between control and a data path is very important.
>>Control protocols tend to be very rich environments which are
>>constantly changing. Take STP, there are so many features that could be
>>added to STP that are much harder to add because it is in the kernel.
>>
>>Maybe what needs to be looked at i sthe design of pppoe or ppp.
> 
> 
> OK, now that we have had our little flight of fancy about what things
> will be like once we get to heaven, can we talk about this bastard
> protocol called PPPoE? :)
> 
> Or are you going to go personally to each ISP in the world and tell
> them they shouldn't use PPPoE? :)
> 
> In any case the problem isn't strictly with PPPoE, since ethernet
> doesn't reorder packets on the wire.  The problem is that the lower
> parts of the Linux network stack lose information.
> 
> Paul.

Nothing is guaranteed, but you may be right at least most of
the time.  Btw, if you want a proprietary tool that
will emulate an ethernet network that reorders packets, I write
such a thing and will give it to you.  It could help you
with testing perhaps.

Also, if you have a PCMCIA Zircom NIC, it seems to reorder packets
just for the hell of it (and no, I'm not using a dual-cpu laptop :))

I don't know of any other protocols that can't handle reordering,
since most of them seem to be designed to run over the real internet,
where reordering/drop/duplication is a part of life.

Ben

-- 
Ben Greear <[email-masked]>       <Ben_Greear AT excite.com>
President of Candela Technologies Inc      http://www.candelatech.com
ScryMUD:  http://scry.wanfear.com     http://scry.wanfear.com/~greear